include \masm32\include\masm32rt.inc

fcmp MACRO cmp1:REQ, cmp2	; -------- floatcmp --------
LOCAL oa
  ffree st(7)
  ifb <cmp2>
	fldz								; no second arg; compare against zero
  else
	oa = (opattr cmp2) AND 127
	if (oa eq 36) or (oa eq 48)
		push cmp2
		fild dword ptr [esp]		; integer or reg32 on stack, then on FPU
		pop eax
	else
		fld cmp2					; real on FPU
	endif
  endif
  ffree st(7)
  fld cmp1
  call fcmpP
ENDM	; --------- end of macro --------
.data
; --------------------- some test variables: ---------------------
f4	REAL4	4.4
f8	REAL8	8.8
f10	REAL10	0.0

.code
fcmpP_proc:
;  Typical call:
;  ffree st(7)
;  fldz								; no second arg; compare against zero
;  ffree st(7)
;  fld MyReal4
;  call fcmpP
fcmpP proc
	push edx
	xor edx, edx	; clear the flag register
	fucompp		; compare ST(0) with ST(1) and pop twice
	fstsw ax		; move FPU flags C1 etc to ax
	sahf
	jpo @F		; jpo=no error
	dec edx		; there
@@:	ja fcPos
	je @F
	dec edx		; negative (-2+1=-1)
@@:	dec edx		; or zero (0-1+1=0)
fcPos:	inc edx		; positive
	xchg edx, [esp]	; save edx, use eax as retval
	pop eax
	ret
fcmpP endp
fcmpP_endp:

fcmpPo proc
	push edx
	xor edx, edx	; clear the flag register
	fcompp		; compare ST(0) with ST(1) and pop twice
	fstsw ax		; move FPU flags C1 etc to ax
	test ah, 64	; C3 is set if ST=0 (bt eax, 14)
	jne @F		; equal, edx=0
	test ah, 1		; C0 (bt eax, 8)
	je fcPos
	dec edx		; negative (-2+1=-1)
@@:	dec edx		; or zero (0-1+1=0)
fcPos:	inc edx		; positive
	pop edx
	ret
fcmpPo endp

start:
	print chr$("expected: higher ", 9)
	mov edx, 12345678h

.data
f10Err	REAL10	1.0e99	; will be written to f4Err
f4Err	REAL4	0.0	; will receive a bad number
.code
	fld f10Err
	fstp f4Err			; for error testing
	finit
	fclex
	; int 3				; < < < < uncomment to start Olly here
	fcmp f4Err		; only one argument: compare against zero
	cmp eax, -2
	je FatError			; there should be an error!!!
C1_start:
	fcmp f4				; only one argument: compare against zero
C1_end:
	.if Sign? && !Zero?
		print "lower"
	.elseif !Sign? && !Zero?
		print "higher"
	.elseif Zero?
		print "equal"
	.elseif Sign? || Zero?
		print "lower or equal"
	.elseif Zero? || !Sign?
		print "higher or equal"
	.endif

	print chr$(13, 10, "expected: lower  ", 9)
C2_start:
	fcmp f4, f8			; compare a real4 against a real8
C2_end:
	.if Sign?
		print "lower"
	.elseif Zero?
		print "equal"
	.else
		print "higher"
	.endif

	print chr$(13, 10, "expected: higher  ", 9)
	mov eax, -1
C3_start:
	fcmp f10, eax		; compare a real10 against eax
C3_end:
	.if Sign?
		print "lower"
	.elseif Zero?
		print "equal"
	.else
		print "higher"
	.endif

	print chr$(13, 10, "expected: equal  ", 9)
C4_start:
	fcmp f10		; compare a real10 against zero
C4_end:
	.if Sign?
		print "lower"
	.elseif Zero?
		print "equal"
	.else
		print "higher"
	.endif

	print chr$(13, 10, 10, "Code sizes:", 13, 10, "proc: ", 9)
	mov eax, fcmpP_endp
	sub eax, fcmpP_proc
	print str$(eax), 13, 10, "call 1:", 9
	mov eax, C1_end
	sub eax, C1_start
	print str$(eax), 13, 10, "call 2:", 9
	mov eax, C2_end
	sub eax, C2_start
	print str$(eax), 13, 10, "call 3:", 9
	mov eax, C3_end
	sub eax, C3_start
	print str$(eax), 13, 10, "call 4:", 9
	mov eax, C4_end
	sub eax, C4_start
	print str$(eax)
@@:	getkey
	exit
FatError:
	print "There was an error"
	jmp @B
end start

RichMasm options
OPT_Tmp2Asm	1
OPT_Wait	0
OPT_Linker	polink	; default is polink (if found), otherwise link.exe

